#include <windows.h>
#include <commdlg.h>
#include <ctype.h>
#include "screen.h"

char cInvertedArray[1920];
int bMouseDown=FALSE;
int iLocStart,iLocEnd,bSelection;

void Edit_LbuttonDown(HWND hWnd,LPARAM lParam) {
    SCREEN far *fpScr;
    HGLOBAL hgScr;
    HMENU hMenu;
    int iTmp,iXlocStart,iYlocStart;
    HDC hDC;
    
    hgScr=(HGLOBAL)GetWindowWord(hWnd,SCREEN_HANDLE);
    if (hgScr == NULL) OutputDebugString("Hosed #1.\r\n");
    fpScr=(SCREEN far *)GlobalLock(hgScr);
    if (fpScr == NULL) OutputDebugString("Hosed #2.\r\n");
    
    hDC=GetDC(hWnd);
    for (iTmp=0; iTmp < 1920; iTmp++) {        
        if (cInvertedArray[iTmp]) {
            PatBlt(hDC,(iTmp%80)*fpScr->cxChar,(int)(iTmp/80)*fpScr->cyChar,
                fpScr->cxChar,fpScr->cyChar,DSTINVERT);                
            cInvertedArray[iTmp]=0;                    
        }    
    }
    bSelection=FALSE;
    hMenu=GetMenu(hWnd);
    EnableMenuItem(hMenu,IDM_COPY,MF_GRAYED);
    ReleaseDC(hWnd,hDC);
    iXlocStart=(int)LOWORD(lParam)/fpScr->cxChar;
    iYlocStart=(int)HIWORD(lParam)/fpScr->cyChar;
    iLocStart=iXlocStart+(iYlocStart*80);
    bMouseDown=TRUE;
    GlobalUnlock(hgScr);
}

void Edit_LbuttonUp(HWND hWnd, LPARAM lParam) {
    SCREEN far *fpScr;
    HGLOBAL hgScr;
    int iTmp,iTmp2;
    HMENU hMenu;
    
    bMouseDown=FALSE;
    if (bSelection) return;
    bSelection=TRUE;
    hgScr=(HGLOBAL)GetWindowWord(hWnd,SCREEN_HANDLE);
    if (hgScr == NULL) OutputDebugString("Hosed #1.\r\n");
    fpScr=(SCREEN far *)GlobalLock(hgScr);
    if (fpScr == NULL) OutputDebugString("Hosed #2.\r\n");        
    iTmp=(int)LOWORD(lParam)/fpScr->cxChar;
    iTmp2=(int)HIWORD(lParam)/fpScr->cyChar;
    GlobalUnlock(hgScr);
    iLocEnd=iTmp+(iTmp2*80);
    if (iLocEnd==iLocStart) {
        bSelection=FALSE;
    } else {
        hMenu=GetMenu(hWnd);
        EnableMenuItem(hMenu,IDM_COPY,MF_ENABLED);
    }    
}    
    
void Edit_MouseMove(HWND hWnd, LPARAM lParam){
    SCREEN far *fpScr;
    HGLOBAL hgScr;
    int iTmp,iTmp2,iXlocCurr,iYlocCurr,iLocCurr,iX,iX2,iY,iY2;
    HSCREENLINE hgScrLine;
    SCREENLINE FAR *fpScrLine;
    HDC hDC;
    
    hgScr=(HGLOBAL)GetWindowWord(hWnd,SCREEN_HANDLE);
    if (hgScr == NULL) OutputDebugString("Hosed #1.\r\n");
    fpScr=(SCREEN far *)GlobalLock(hgScr);
    if (fpScr == NULL) OutputDebugString("Hosed #2.\r\n");
    hDC = GetDC(hWnd);
    iXlocCurr=(int)LOWORD(lParam)/fpScr->cxChar;
    iYlocCurr=(int)HIWORD(lParam)/fpScr->cyChar;
    iLocCurr=iXlocCurr+(iYlocCurr*80);
    if (iLocCurr > iLocStart) {    
        for (iTmp=0; iTmp < iLocStart; iTmp++) {        
            if (cInvertedArray[iTmp]) {
                PatBlt(hDC,(iTmp%80)*fpScr->cxChar,(int)(iTmp/80)*fpScr->cyChar,
                    fpScr->cxChar,fpScr->cyChar,DSTINVERT);                
                cInvertedArray[iTmp]=0;                    
            }    
        }
        iX=(iLocStart%80);
        iY=(int)(iLocStart/80);
        iX2=(iLocCurr%80);
        iY2=(int)(iLocCurr/80);
        if (iY==iY2) {
            hgScrLine=GetScreenLineFromY(fpScr,iY);
            fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
            for (iTmp2= iX; iTmp2 < iX2; iTmp2++) {
                if ((!cInvertedArray[iTmp2+(80*iY)])&& fpScrLine->text[iTmp2]) {
                    PatBlt(hDC,(iTmp2)*fpScr->cxChar,iY*fpScr->cyChar,
                        fpScr->cxChar,fpScr->cyChar,DSTINVERT);
                    cInvertedArray[iTmp2+(80*iY)]=fpScrLine->text[iTmp2];
                }    
            }    
            LINE_MEM_UNLOCK(hgScrLine);
        }            
        else {
            hgScrLine=GetScreenLineFromY(fpScr,iY);
            fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
            for (iTmp2= iX; iTmp2 < 80; iTmp2++) {
                if ((!cInvertedArray[iTmp2+(80*iY)])&& fpScrLine->text[iTmp2]) {
                    PatBlt(hDC,(iTmp2)*fpScr->cxChar,iY*fpScr->cyChar,
                        fpScr->cxChar,fpScr->cyChar,DSTINVERT);
                    cInvertedArray[iTmp2+(80*iY)]=fpScrLine->text[iTmp2];
                }    
            }                
            for (iTmp=iY+1; iTmp < iY2; iTmp++) {
                hgScrLine=GetScreenLineFromY(fpScr,iTmp);
                fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
                for (iTmp2= 0; iTmp2 < 80; iTmp2++) {
                    if ((!cInvertedArray[iTmp2+(80*iTmp)])&& fpScrLine->text[iTmp2]) {
                        PatBlt(hDC,(iTmp2)*fpScr->cxChar,iTmp*fpScr->cyChar,
                            fpScr->cxChar,fpScr->cyChar,DSTINVERT);
                        cInvertedArray[iTmp2+(80*iTmp)]=fpScrLine->text[iTmp2];
                    }    
                }    
                LINE_MEM_UNLOCK(hgScrLine);
            }
            if (!(iY2==iY)) {
                hgScrLine=GetScreenLineFromY(fpScr,iY2);
                fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
                for (iTmp2= 0; iTmp2 < iX2; iTmp2++) {
                    if ((!cInvertedArray[iTmp2+(80*iY2)])&& fpScrLine->text[iTmp2]) {
                        PatBlt(hDC,(iTmp2)*fpScr->cxChar,iY2*fpScr->cyChar,
                            fpScr->cxChar,fpScr->cyChar,DSTINVERT);
                        cInvertedArray[iTmp2+(80*iY2)]=fpScrLine->text[iTmp2];
                    }    
                }    
                LINE_MEM_UNLOCK(hgScrLine);                
            }                

        }    
        for (iTmp=iLocCurr; iTmp < 1920; iTmp++) {        
            if (cInvertedArray[iTmp]) {
                PatBlt(hDC,(iTmp%80)*fpScr->cxChar,(int)(iTmp/80)*fpScr->cyChar,
                    fpScr->cxChar,fpScr->cyChar,DSTINVERT);                
                cInvertedArray[iTmp]=0;                    
            }    
        }
    } else { /* going backwards */
        for (iTmp=0; iTmp < iLocCurr; iTmp++) {        
            if (cInvertedArray[iTmp]) {
                PatBlt(hDC,(iTmp%80)*fpScr->cxChar,(int)(iTmp/80)*fpScr->cyChar,
                    fpScr->cxChar,fpScr->cyChar,DSTINVERT);                
                cInvertedArray[iTmp]=0;                    
            }    
        }
        iX=(iLocCurr%80);
        iY=(int)(iLocCurr/80);
        iX2=(iLocStart%80);
        iY2=(int)(iLocStart/80);
        if (iY==iY2) {
            hgScrLine=GetScreenLineFromY(fpScr,iY);
            fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
            for (iTmp2= iX; iTmp2 < iX2; iTmp2++) {
                if ((!cInvertedArray[iTmp2+(80*iY)])&& fpScrLine->text[iTmp2]) {
                    PatBlt(hDC,(iTmp2)*fpScr->cxChar,iY*fpScr->cyChar,
                        fpScr->cxChar,fpScr->cyChar,DSTINVERT);
                    cInvertedArray[iTmp2+(80*iY)]=fpScrLine->text[iTmp2];
                }    
            }    
            LINE_MEM_UNLOCK(hgScrLine);
        }            
        else {
            hgScrLine=GetScreenLineFromY(fpScr,iY);
            fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
            for (iTmp2= iX; iTmp2 < 80; iTmp2++) {
                if ((!cInvertedArray[iTmp2+(80*iY)])&& fpScrLine->text[iTmp2]) {
                    PatBlt(hDC,(iTmp2)*fpScr->cxChar,iY*fpScr->cyChar,
                        fpScr->cxChar,fpScr->cyChar,DSTINVERT);
                    cInvertedArray[iTmp2+(80*iY)]=fpScrLine->text[iTmp2];
                }    
            }                
            for (iTmp=iY+1; iTmp < iY2; iTmp++) {
                hgScrLine=GetScreenLineFromY(fpScr,iTmp);
                fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
                for (iTmp2= 0; iTmp2 < 80; iTmp2++) {
                    if ((!cInvertedArray[iTmp2+(80*iTmp)])&& fpScrLine->text[iTmp2]) {
                        PatBlt(hDC,(iTmp2)*fpScr->cxChar,iTmp*fpScr->cyChar,
                            fpScr->cxChar,fpScr->cyChar,DSTINVERT);
                        cInvertedArray[iTmp2+(80*iTmp)]=fpScrLine->text[iTmp2];
                    }    
                }    
                LINE_MEM_UNLOCK(hgScrLine);
            }
            if (!(iY2==iY)) {
                hgScrLine=GetScreenLineFromY(fpScr,iY2);
                fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
                for (iTmp2= 0; iTmp2 < iX2; iTmp2++) {
                    if ((!cInvertedArray[iTmp2+(80*iY2)])&& fpScrLine->text[iTmp2]) {
                        PatBlt(hDC,(iTmp2)*fpScr->cxChar,iY2*fpScr->cyChar,
                            fpScr->cxChar,fpScr->cyChar,DSTINVERT);
                        cInvertedArray[iTmp2+(80*iY2)]=fpScrLine->text[iTmp2];
                    }    
                }    
                LINE_MEM_UNLOCK(hgScrLine);                
            }                

        }    
        for (iTmp=iLocStart; iTmp < 1920; iTmp++) {        
            if (cInvertedArray[iTmp]) {
                PatBlt(hDC,(iTmp%80)*fpScr->cxChar,(int)(iTmp/80)*fpScr->cyChar,
                    fpScr->cxChar,fpScr->cyChar,DSTINVERT);                
                cInvertedArray[iTmp]=0;                    
            }    
        }
        
    }            
    ReleaseDC(hWnd,hDC);
    GlobalUnlock(hgScr);
}

void Edit_ClearSelection(SCREEN far *fpScr) {
    int iTmp;
    HDC hDC;
    HMENU hMenu;

    hDC=GetDC(fpScr->hWnd);
    for (iTmp=0; iTmp < 1920; iTmp++) {        
        if (cInvertedArray[iTmp]) {
            PatBlt(hDC,(iTmp%80)*fpScr->cxChar,(int)(iTmp/80)*fpScr->cyChar,
                fpScr->cxChar,fpScr->cyChar,DSTINVERT);                
            cInvertedArray[iTmp]=0;                    
        }    
    }
    bSelection=FALSE;
    hMenu=GetMenu(fpScr->hWnd);
    EnableMenuItem(hMenu,IDM_COPY,MF_GRAYED);    
    ReleaseDC(fpScr->hWnd,hDC);
}    

void Edit_Copy(HWND hWnd) {
    int iTmp,iIdx;
    HGLOBAL hCutBuffer;
    LPSTR lpCutBuffer;
    
    hCutBuffer= GlobalAlloc(GHND,(DWORD) 1921);
    lpCutBuffer= GlobalLock(hCutBuffer);

    if (iLocStart > iLocEnd) { /* swap variables */
        iTmp=iLocStart;
        iLocStart=iLocEnd;
        iLocEnd=iLocStart;
    }        
    iTmp=iLocStart;
    iIdx=0;
    while (iTmp < iLocEnd) {
        if (!cInvertedArray[iTmp]) {
            lpCutBuffer[iIdx++]='\r';
            lpCutBuffer[iIdx++]='\n';
            iTmp= (((int)(iTmp/80))+1)*80;            
            continue;
        }
        lpCutBuffer[iIdx++]=cInvertedArray[iTmp++];
    }
    lpCutBuffer[iIdx]=0;
    GlobalUnlock(hCutBuffer);
    OpenClipboard(hWnd);
    EmptyClipboard();
    SetClipboardData(CF_TEXT,hCutBuffer);
    CloseClipboard();
}

void Edit_Paste(HWND hWnd) {
    HGLOBAL hClipMemory;
    static HGLOBAL hMyClipBuffer;
    LPSTR lpClipMemory,lpMyClipBuffer;
    HGLOBAL hgScr;
    HWND hwndNetwork;

    if (hMyClipBuffer) GlobalFree(hMyClipBuffer);
    OpenClipboard(hWnd);
    hClipMemory = GetClipboardData(CF_TEXT);
    hMyClipBuffer = GlobalAlloc(GHND,GlobalSize(hClipMemory));
    lpMyClipBuffer= GlobalLock(hMyClipBuffer);
    lpClipMemory= GlobalLock(hClipMemory);
    
    hgScr=(HGLOBAL)GetWindowWord(hWnd,SCREEN_HANDLE);
    if (hgScr == NULL) OutputDebugString("Hosed #1.\r\n");
    hwndNetwork=FindWindow("wintelWClass",NULL);

    lstrcpy(lpMyClipBuffer,lpClipMemory);
    OutputDebugString(lpMyClipBuffer);
    PostMessage(hwndNetwork,WM_MYSCREENBLOCK,(WPARAM)hMyClipBuffer,
                    (HSCREEN)hgScr);                
    CloseClipboard();                    
    GlobalUnlock(hClipMemory);
    GlobalUnlock(hMyClipBuffer);    
}

void Edit_LbuttonDblclk(HWND hWnd,LPARAM lParam) {
    HDC hDC;
    SCREEN far *fpScr;
    HGLOBAL hgScr;
    int iTmp,iTmp2,iXlocStart,iYloc;
    HSCREENLINE hgScrLine;
    SCREENLINE FAR *fpScrLine;
        
    hgScr=(HGLOBAL)GetWindowWord(hWnd,SCREEN_HANDLE);
    if (hgScr == NULL) OutputDebugString("Hosed #1.\r\n");
    fpScr=(SCREEN far *)GlobalLock(hgScr);
    if (fpScr == NULL) OutputDebugString("Hosed #2.\r\n");
    
    hDC=GetDC(hWnd);
    for (iTmp=0; iTmp < 1920; iTmp++) {        
        if (cInvertedArray[iTmp]) {
            PatBlt(hDC,(iTmp%80)*fpScr->cxChar,(int)(iTmp/80)*fpScr->cyChar,
                fpScr->cxChar,fpScr->cyChar,DSTINVERT);                
            cInvertedArray[iTmp]=0;                    
        }    
    }
    bSelection=FALSE;
    iXlocStart=(int)LOWORD(lParam)/fpScr->cxChar;
    iYloc=(int)HIWORD(lParam)/fpScr->cyChar;
    iLocStart=iXlocStart+(iYloc*80);
    
    hgScrLine=GetScreenLineFromY(fpScr,iYloc);
    fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
    
    iTmp=iXlocStart;
#ifdef OLD_WAY
    while (isalnum((int)fpScrLine->text[iTmp])) {
#else
    while ((fpScrLine->text[iTmp])&&(!isspace((int)fpScrLine->text[iTmp]))&&(iTmp<fpScr->width)) {
#endif
        PatBlt(hDC,iTmp*fpScr->cxChar,iYloc*fpScr->cyChar,
             fpScr->cxChar,fpScr->cyChar,DSTINVERT);                    
        cInvertedArray[iTmp+(iYloc*80)]=fpScrLine->text[iTmp];
        iTmp++;
    }
    iTmp2=iXlocStart-1;
#ifdef OLD_WAY
    while (isalnum((int)fpScrLine->text[iTmp2])) {
#else
    while ((fpScrLine->text[iTmp2])&&(!isspace((int)fpScrLine->text[iTmp2]))&&(iTmp2>=0)) {
#endif
        PatBlt(hDC,iTmp2*fpScr->cxChar,iYloc*fpScr->cyChar,
             fpScr->cxChar,fpScr->cyChar,DSTINVERT);                        
        cInvertedArray[iTmp2+(iYloc*80)]=fpScrLine->text[iTmp2];
        iTmp2--;
    }    
    iLocStart=(iTmp2+1)+(iYloc*80);
    iLocEnd=(iTmp)+(iYloc*80);        

    bSelection=TRUE;
    ReleaseDC(hWnd,hDC);
    LINE_MEM_UNLOCK(hgScrLine);        
    GlobalUnlock(hgScr);
}

void Edit_TripleClick(HWND hWnd,LPARAM lParam) {
    HDC hDC;
    SCREEN far *fpScr;
    HGLOBAL hgScr;
    int iTmp,iYloc;
    HSCREENLINE hgScrLine;
    SCREENLINE FAR *fpScrLine;
        
    OutputDebugString("Triple Click \r\n");
    hgScr=(HGLOBAL)GetWindowWord(hWnd,SCREEN_HANDLE);
    if (hgScr == NULL) OutputDebugString("Hosed #1.\r\n");
    fpScr=(SCREEN far *)GlobalLock(hgScr);
    if (fpScr == NULL) OutputDebugString("Hosed #2.\r\n");
    
    hDC=GetDC(hWnd);
    for (iTmp=0; iTmp < 1920; iTmp++) {        
        if (cInvertedArray[iTmp]) {
            PatBlt(hDC,(iTmp%80)*fpScr->cxChar,(int)(iTmp/80)*fpScr->cyChar,
                fpScr->cxChar,fpScr->cyChar,DSTINVERT);                
            cInvertedArray[iTmp]=0;                    
        }    
    }
    bSelection=FALSE;
    iYloc=(int)HIWORD(lParam)/fpScr->cyChar;
    iLocStart=(iYloc*80);
    
    hgScrLine=GetScreenLineFromY(fpScr,iYloc);
    fpScrLine=(SCREENLINE far *)LINE_MEM_LOCK(hgScrLine);
    
    for (iTmp=0; iTmp<80; iTmp++) {
        if (fpScrLine->text[iTmp]) {
            PatBlt(hDC,iTmp*fpScr->cxChar,iYloc*fpScr->cyChar,
                 fpScr->cxChar,fpScr->cyChar,DSTINVERT);                    
            cInvertedArray[iTmp+(iYloc*80)]=fpScrLine->text[iTmp];
        } else break;    
    }
    iLocEnd=(iTmp+(iYloc*80));

    bSelection=TRUE;
    ReleaseDC(hWnd,hDC);
    LINE_MEM_UNLOCK(hgScrLine);        
    GlobalUnlock(hgScr);
}
