#include <windows.h>
#include <direct.h>             /* for _getcwd(), rmdir(), mkdir() decls */
#include <ctype.h>              /* for isalnum() decl */
#include <stdio.h>              /* for remove() decl  */
#include <memory.h>
#include "wintel.h"

#define CRESP(s,A) send(s, (char FAR *)(messs[(A)]),lstrlen(messs[(A)]),NULL)
#define FCRESP(s,A,B,C) {char msg[80];wsprintf(msg,messs[(A)],B,C);send(s,msg,lstrlen(msg),NULL);}

static char *messs[]={
    "220 NCSA Windows FTP server ready \015\012",           /*0*/
    "451 Error in processing list command \015\012",        /*1*/
    "221 Goodbye \015\012",                                 /*2*/
    "200 PORT command successful. \015\012",                /*3*/
    "150 Opening %ls mode connection for file %ls \015\012",/*4*/
    "226 Transfer complete \015\012",                       /*5*/
    "200 Type set to A, ASCII transfer mode \015\012",      /*6*/
    "200 Type set to I, binary transfer mode \015\012",     /*7*/
    "500 Command not understood \015\012",                  /*8*/
    "200 Okay \015\012",                                    /*9*/
    "230 User logged in \015\012",                          /*10*/
    "550 File not found \015\012",                          /*11*/
    "501 Directory not present or syntax error\015\012",    /*12*/
    "250 Chdir okay\015\012",                               /*13*/
    "257 \"",                                               /*14*/
    "\" is the current directory \015\012",                 /*15*/
    "501 File not found \015\012",                          /*16*/
    "504 Parameter not accepted, not implemented\015\012",  /*17*/
    "200 Stru F, file structure\015\012",                   /*18*/
    "200 Mode S, stream mode\015\012",                      /*19*/
    "202 Allocate and Account not required for this server\015\012",
    "501 Cannot open file to write, check for valid name\015\012",
    "530 USER and PASS required to activate me\015\012",    /*22*/
    "331 Password required\015\012",                        /*23*/
    "530 Login failed\015\012",                             /*24*/
    "331 Guest login ok, send e-mail address as password.\015\012",    /*25*/
    "530 Guest login disabled - login failed.\015\012",     /*26*/
    "552 Disk write error, probably disk full\015\012",     /*27*/
    "214-NCSA Windows FTP server supported commands:\015\012",
    "    USER  PORT  RETR  ALLO  PASS  STOR  CWD   XCWD  XPWD LIST NLST\015\012",
    "    HELP  QUIT  MODE  TYPE  STRU  ACCT  CDUP  DELE  MKD  RMD  NOOP\015\012", /*30*/
    "    Macintosh and MS-DOS versions of NCSA Telnet and FTP are also available.\015\012",
    "214 Direct comments and bug reports to pctelbug@ncsa.uiuc.edu\015\012",
    "501 Directory access denied.\015\012",                 /*33*/
    "553 File access denied.\015\012",                      /*34*/
    "\" created\015\012",                                   /*35*/
    "553 File name not allowed\015\012",                    /*36*/
    "502 Command not implemented\015\012",                  /*37*/
    "426 Transfer aborted\015\012",                         /*38*/
    "421 FTP server is disabled.\015\012",                  /*39*/
    ""};                                                    /*40*/

SOCKET socketFTPListen;
HFTPCON FTPConList=NULL;
unsigned char buf_array[1025];
unsigned char far *buf;
extern int FTP_access;   /* 0 = no access, 1 = restricted access, 2 = unrestricted access */
int bypass_passwd=0;

void ChangeFTPDirectoryUp(FTPCON far *pCon) {
    char far *lpPath;

    lpPath=(char far *)GlobalLock(pCon->hPath);
    if (lpPath) {
        StripLastFromPath(lpPath);
        if (!lpPath[0]) {
            lpPath[0]='\\';
            lpPath[1]=0;
        }
        GlobalUnlock(pCon->hPath); 
    }
}

int ChangeFTPDirectory(FTPCON far *pCon,char far *dirnm) {
    int iLen, iTmp;
    char strDir[256];
    char far *strOldDir;

    if (!dirnm)
        return (0);

    wsprintf(strTmp,"ChangeFTPDirectory(pCon,\"%ls\")\r\n",dirnm);
//    OutputDebugString(strTmp);

    AnsiLower(dirnm);
    if (!lstrncmp(dirnm,"..",2)) {
        ChangeFTPDirectoryUp(pCon);
        dirnm+=2;
        if (dirnm[0] != '\\')
            return(1);
    }
    iLen = lstrlen(dirnm);
    if (iLen>1)      /* Trim trailing slash, unless it's a drive specifier */
        if ((dirnm[iLen]=='\\') && (dirnm[iLen-1]!=':'))    /* (i.e. "c:\") */
            dirnm[iLen]=0;

    while ((!isalnum(dirnm[iLen]))&&(dirnm[iLen]!='\\')&&(dirnm[iLen]!=':')&&(iLen>0)) {
        if (((iLen>1)&&(dirnm[iLen]=='\\')&&(dirnm[iLen-1]==':'))||(dirnm[iLen]==':'))
            break;
        dirnm[iLen]=0;
        iLen--;
    }
    wsprintf(strTmp,"After attacking with the WeedWacker(tm) = \"%ls\")\r\n",dirnm);
//    OutputDebugString(strTmp);

    if (iLen<0)
        return(1);
    MungeNameToFullPathName(pCon,dirnm);
    if (dirnm[lstrlen(dirnm)-1]==':')
        lstrcat(dirnm,"\\");
    lstrcpy(strDir,dirnm);

    wsprintf(strTmp,"Testing \"%ls\"...\r\n",strDir);
//    OutputDebugString(strTmp);
    if (lstrlen(strDir)==3) {
        iTmp=GetDriveType(strDir[0] - 'a');     /* is root dir of a drive - check to */
        wsprintf(strTmp,"GetDriveType() returned %d.\r\n",iTmp);
    } else {                                    /* see if drive exists */
        iTmp=(FileType(strDir) == IS_DIRECTORY);
        wsprintf(strTmp,"GetDriveType() returned %d.\r\n",iTmp);
    }
//    OutputDebugString(strTmp);
    if (iTmp) {
        strOldDir=(char far *)GlobalLock(pCon->hPath);
        if (!strOldDir) {
            OutputDebugString("Couldn't lock path down.\r\n");
            return(0);
        }
        lstrcpy(strOldDir,strDir);
        GlobalUnlock(pCon->hPath);
    }
    return(iTmp);
}

int RemovePathname(FTPCON far *pCon,char far *pathnm, int iToRemove) {
    int iLen,iTmp;

    if (!pathnm)
        return (0);
    AnsiLower(pathnm);
    if (!lstrncmp(pathnm,"..",2)) {
        ChangeFTPDirectoryUp(pCon);
        pathnm+=2;
        if (pathnm[0] != '\\')
            return(1);
    }
    iLen = lstrlen(pathnm);
    if (iLen>1)      /* Trim trailing slash, unless it's a drive specifier */
        if ((pathnm[iLen]=='\\') && (pathnm[iLen-1]!=':'))    /* (i.e. "c:\") */
            pathnm[iLen]=0;
    while ((!isalnum(pathnm[iLen]))&&(iLen>0)) {
        if (((iLen>1)&&(pathnm[iLen]=='\\')&&(pathnm[iLen-1]==':'))||(pathnm[iLen]==':'))
            break;
        pathnm[iLen]=0;
        iLen--;
    }
    if (iLen<0)
        return(0);
    MungeNameToFullPathName(pCon,pathnm);
    if (!checkDirectoryAccess(pCon, pathnm, WRITE_ACCESS))
        return(-1);     /* access denied */
    iTmp=FileType(pathnm);
    if (iToRemove&iTmp) {
        if (iTmp == IS_DIRECTORY)
            return(removedir(pathnm)==0);
        if (iTmp == IS_FILE) {
            char bufTmp[256];
            lstrcpy((char far *)bufTmp,pathnm);
            return(remove(bufTmp)==0);
        }
    }
    return(0);
}

int InitFTPListen(void) {
    struct sockaddr_in sockaddr;
    char bufTmp[40];

    GetPrivateProfileString("FTP","access","none",bufTmp,40,"ncsa_net.ini");
    if (!lstrcmp(bufTmp,"off"))
        FTP_access=-1;
      else if (!lstrcmp(bufTmp,"none"))
        FTP_access=0;
      else if (!lstrcmp(bufTmp,"restricted") || !lstrcmp(bufTmp,"yes"))
        FTP_access=1;
      else if (!lstrcmp(bufTmp,"unrestricted"))
        FTP_access=2;

    if (FTP_access == -1)
        return(0);

    sockaddr.sin_family = AF_INET ;  
    /* 
        Logical name had been supplied for makeport. 
        Assign port from system ( sin_port = 0 ), and accept
        from all network interfaces for multi-homed host 
        ( INADDR_ANY ).
    */
    sockaddr.sin_addr.s_addr = htonl( INADDR_ANY );
    sockaddr.sin_port = htons(IPPORT_FTP);     /* should be defined in winsock.h  = 21 */

    if( (socketFTPListen = socket( sockaddr.sin_family, SOCK_STREAM, IPPROTO_TCP )) < 0 ) {
        OutputDebugString("socket create error\r\n");
        return 0;
    }
    /*  Bind name to socket */
    if( bind((int)socketFTPListen,(struct sockaddr far *)&sockaddr,(int)sizeof( struct sockaddr_in ) ) < 0 ) {
        OutputDebugString("socket_init: could not bind to sockaddr\r\n");
        return 0;
    }

    /*  Listen at socket for TCP port, buffer for 5 pending connections */
    if (listen( socketFTPListen, 5 )) {
        OutputDebugString("Error trying to listen to socket!\r\n");
        return(0);
    }
    return 1;
}

int CloseFTP(void) {
    HFTPCON hCurrCon=FTPConList,
            hNextCon;
    FTPCON far *pCurrCon;

    if (FTP_access == -1)
        return(0);

    while (hCurrCon) {
        pCurrCon=(FTPCON far *) GlobalLock(hCurrCon);
        if (pCurrCon==NULL) {
            OutputDebugString("Unable to lock down FTP connection while closing!\r\n");
            return(0);
        }
        if (pCurrCon->ftpDataState != FTPSTATE_CLOSED)
            closesocket(pCurrCon->datasocket);
        closesocket(pCurrCon->socket);
        hNextCon=pCurrCon->hNext;
        GlobalFree(pCurrCon->hUser);
        GlobalFree(pCurrCon->hPath);
        GlobalFree(pCurrCon->hData);
        GlobalUnlock(hCurrCon);
        GlobalFree(hCurrCon);
        hCurrCon=hNextCon;
    }
    closesocket(socketFTPListen);
    FTPConList=NULL;
    socketFTPListen=(SOCKET)SOCKET_ERROR;
    return(1);
}

int addFTPConnectToList(SOCKET s, struct sockaddr far *sa) {
    HFTPCON hCurrCon, hNewCon;
    FTPCON far *pCurrCon, far *pNewCon;

    hNewCon=GlobalAlloc(GHND,sizeof(FTPCON));
    pNewCon=(FTPCON far *)GlobalLock(hNewCon);
    if (!pNewCon) {
        OutputDebugString("No memory available for FTP Connection!\r\n");
        if (hNewCon)
            GlobalFree(hNewCon);
        return(0);
    }
    pNewCon->socket=s;
    if (FTPConList) {
        pNewCon->hPrev=NULL;
        pNewCon->hNext=FTPConList;
        pCurrCon=(FTPCON far *)GlobalLock(FTPConList);
        if (!pCurrCon) {
            OutputDebugString("PANIC:  error locking FTP connection list.\r\n");
            GlobalUnlock(hNewCon);
            GlobalFree(hNewCon);
            return(0);
        }
        pCurrCon->hPrev=hNewCon;
        GlobalUnlock(hCurrCon);
        GlobalUnlock(hNewCon);
        FTPConList=hNewCon;
        return(1);
    } else {
        pNewCon->hNext=pNewCon->hPrev=NULL;
        GlobalUnlock(hNewCon);
        FTPConList=hNewCon;
        return(1);
    }
    return(0);
}

void acceptNewFTPConnection(void) {
    struct sockaddr sa;
    int iAddrLen;
    SOCKET s;
    FTPCON far *pCon;

    iAddrLen=sizeof(struct sockaddr);
    s=accept(socketFTPListen,(struct sockaddr far *)&sa,(int far *)&iAddrLen);
    if (s==INVALID_SOCKET)
        OutputDebugString("[INVALID_SOCKET]");
      else
        OutputDebugString("[New FTP Connection]\r\n");
    addFTPConnectToList(s,&sa);
    pCon=(FTPCON far *)GlobalLock(FTPConList);
    pCon->ftpstate=0;
    pCon->hPath=NULL;
    ProcessFTPCommand(pCon);
    GlobalUnlock(FTPConList);
}

SOCKET openFTPDataSocket(FTPCON far *pCon) {
    struct sockaddr_in sa;
    SOCKET s;

    sa.sin_family = AF_INET ;  
    sa.sin_addr.s_addr = htonl( INADDR_ANY );
    sa.sin_port = IPPORT_FTP_DATA;     /* should be defined in ftp.h  = 20 */

    if( (s = socket( sa.sin_family, SOCK_STREAM, IPPROTO_TCP )) < 0 ) {
        OutputDebugString("socket create error\r\n");
        return ((unsigned int)SOCKET_ERROR);
    }

    /*  Bind name to socket */
    if( bind((int)s,(struct sockaddr far *)&sa,(int)sizeof( struct sockaddr_in ) ) < 0 ) {
        OutputDebugString("socket_init: could not bind to sockaddr\r\n");
        return ((unsigned int)SOCKET_ERROR);
    }
    wsprintf(strTmp,"Opening data socket to port %d.\r\n",pCon->sa.sin_port);
    OutputDebugString(strTmp);
    if (connect(s,(struct sockaddr far*) &pCon->sa, sizeof(struct sockaddr))){
        OutputDebugString("Connect error for s \r\n");
        return ((unsigned int)SOCKET_ERROR);
    }
    return((int)s);
}


void ProcessFTPConnections(void) {
    HFTPCON hCurrCon, hNextCon;
    FTPCON far *pCurrCon;
    FTPCON far *pTmpCon;
    fd_set filedes;
    unsigned long count;
    int cnt;
    char far *lpUser;

    if (FTP_access == -1)
        return;

    /* See if there are any new FTP connections pending */
    FD_ZERO(&filedes);
    FD_SET(socketFTPListen,&filedes);
    if (select(0,(fd_set FAR *)&filedes,NULL,NULL,NULL)) {
        if (FD_ISSET(socketFTPListen,&filedes)) {
            acceptNewFTPConnection();
        }
    }

    /* Deal with any pending data for open Telnet sessions */
    hCurrCon=FTPConList;
    while (hCurrCon) {
        pCurrCon=(FTPCON far *) GlobalLock(hCurrCon);
        if (pCurrCon==NULL) {
            OutputDebugString("Unable to lock down FTP connection while processing!\r\n");
            break;
        }

        if (pCurrCon->ftpDataState)
            ProcessFTPDataCommand(pCurrCon);

        if (ioctlsocket((SOCKET)pCurrCon->socket,(long)FIONREAD,(u_long FAR *)&count)==
                    SOCKET_ERROR) {     /* Socket was closed by other end */
            lpUser=(char far *)GlobalLock(pCurrCon->hUser);
            OutputDebugString("FTP server: logout:");
            if (lpUser) {
                wsprintf(strTmp,"User \"%ls\" logged out.\r\n",lpUser);
//                OutputDebugString(strTmp);
                GlobalUnlock(pCurrCon->hUser);
            } else
//                OutputDebugString("unrecognized user.\r\n");
            GlobalFree(pCurrCon->hUser);
            GlobalFree(pCurrCon->hPath);
            GlobalFree(pCurrCon->hData);
            if (pCurrCon->hPrev) {
                pTmpCon=(FTPCON far *)GlobalLock(pCurrCon->hPrev);
                pTmpCon->hNext=pCurrCon->hNext;
                GlobalUnlock(pCurrCon->hPrev);
            } else
                FTPConList=pCurrCon->hNext;
            if (pCurrCon->hNext) {
                pTmpCon=(FTPCON far *)GlobalLock(pCurrCon->hNext);
                pTmpCon->hPrev=pCurrCon->hPrev;
                GlobalUnlock(pCurrCon->hNext);
            }
            hNextCon=pCurrCon->hNext;
            GlobalUnlock(hCurrCon);
            GlobalFree(hCurrCon);
            hCurrCon=hNextCon;
            break;
        }
        if (count) {
            cnt=recv(pCurrCon->socket,buf_array,1024,NULL);
            buf_array[cnt]=0;
            buf=buf_array;
            count=0;
            while ((!isalnum(*buf)) && (count<(unsigned long)cnt)) {
                buf++;
                count++;
            }
            ProcessFTPCommand(pCurrCon);
        }
        hNextCon=pCurrCon->hNext;
        GlobalUnlock(hCurrCon);
        hCurrCon=hNextCon;
    }
}

void ProcessFTPCommand(FTPCON far *pCon) {
    int i,lstype,iTmp;
    char far *lpPath;
    char far *lpUser;
    char strTmp[80];

    switch (pCon->ftpstate) {
        case 0:
//            OutputDebugString("FTP login request.\r\n");
            pCon->mode=FASCII;

            getpeername(pCon->socket,(struct sockaddr far*)&pCon->sa,&i);
            wsprintf(strTmp,"FTP connection from %d.%d.%d.%d:%d\r\n", pCon->sa.sin_addr.S_un.S_un_b.s_b1,
                     pCon->sa.sin_addr.S_un.S_un_b.s_b2,pCon->sa.sin_addr.S_un.S_un_b.s_b3,
                     pCon->sa.sin_addr.S_un.S_un_b.s_b4,pCon->sa.sin_port);
//            OutputDebugString(strTmp);

        case 1:
            if (FTP_access==0) {    /* FTP access is turned off, refuse connection */
                CRESP(pCon->socket,39);
                break;
            }

            pCon->hData=GlobalAlloc(GHND,DATA_BUF_SIZE);
            if (!pCon->hData)
                OutputDebugString("Failed FTP data block allocation!\r\n");
            pCon->wDataIdx=pCon->wDataLen=0;
            pCon->ftpDataState=FTPSTATE_CLOSED;
            pCon->hFile=HFILE_ERROR;
            pCon->hReadPath=GlobalAlloc(GHND,256);
            lpPath=(char far *)GlobalLock(pCon->hReadPath);
            if (lpPath) {
                lpPath[0]=0;
                GlobalUnlock(pCon->hPath);
            } else
                OutputDebugString("failed read path allocation!\r\n");
            pCon->hWritePath=GlobalAlloc(GHND,256);
            lpPath=(char far *)GlobalLock(pCon->hWritePath);
            if (lpPath) {
                lpPath[0]=0;
                GlobalUnlock(pCon->hPath);
            } else
                OutputDebugString("failed read path allocation!\r\n");
            pCon->datasocket=(unsigned int)SOCKET_ERROR;
            pCon->hPath=GlobalAlloc(GHND,256);
            lpPath=(char far *)GlobalLock(pCon->hPath);
            lpPath[0]=0;
            if (lpPath) {
                char bufTmp[256];

                _getcwd(bufTmp,255);
                lstrcpy(lpPath,(LPSTR)bufTmp);
                AnsiLower(lpPath);
                GlobalUnlock(pCon->hPath);
            } else
                OutputDebugString("failed path allocation!\r\n");

            pCon->hUser=GlobalAlloc(GHND,32);
            lpUser=(char far *)GlobalLock(pCon->hUser);
            lpUser[0]=0;
            if (!lpUser)
                OutputDebugString("Failed username space allocation!\r\n");
            GlobalUnlock(pCon->hUser);
            CRESP(pCon->socket,0);

            if (FTP_access==2)      /* FTP access is unrestricted - don't need passwd */
                pCon->ftpstate=5;
              else                  /* FTP access is restricted - _DO_ need passwd */
                pCon->ftpstate=3;
            break;

        case 3:     /* check for passwords */
        case 4:
            if(!lstrncmp("USER",buf,4)) {
                lpUser=(char far *)GlobalLock(pCon->hUser);
                if (lpUser) {
                    lstrcpyn(lpUser,&buf[5],16);      /* keep user name */
                    i=lstrlen(lpUser);
                    do {
                        i--;
                        if (isalnum(lpUser[i]))
                            break;
                          else
                            lpUser[i]=0;
                    } while (i);
                    wsprintf(strTmp,"User \"%ls\" login request.\r\n",lpUser);
//                    OutputDebugString(strTmp);
                    pCon->iAnonymous=0;
                    switch (accessCheck(lpUser)) {
                        case NEED_PASSWORD:
                            CRESP(pCon->socket,23);     /* Password req */
                            pCon->ftpstate=4;           /* wait for password */
                            break;
                        case PASSWORD_NREQ:
                            CRESP(pCon->socket,10);     /* User logged in */
                            GetAccessPaths(pCon);
                            pCon->ftpstate=5;           /* "wait for command" state */
                            break;
                        case ANON_LOGIN:
                            pCon->iAnonymous=1;
                            CRESP(pCon->socket,25);     /* Ask for email address */
                            pCon->ftpstate=4;           /* wait for password */
                            break;
                        case ANON_LOGIN_DENIED:         /* anon. access turned off */
                            CRESP(pCon->socket,26);
                            pCon->ftpstate=3;
                            break;
                    }
                    GlobalUnlock(pCon->hUser);
                } else
                    CRESP(pCon->socket,39);
                break;
            } else
            if(!lstrncmp("PASS",buf,4)) {
                lpUser=(char far *)GlobalLock(pCon->hUser);
                if (lpUser) {
                    if (pCon->iAnonymous) {
                        lstrcat(lpUser,":");
                        lstrcat(lpUser,buf+5);
                        i=lstrlen(lpUser);
                        do {
                            i--;
                            if (isalnum(lpUser[i]))
                                break;
                              else
                                lpUser[i]=0;
                        } while (i);
                        CRESP(pCon->socket,10); /* User logged in. */
                        GetAccessPaths(pCon);
                        pCon->ftpstate=5;
                    } else {  /* end if (iAnonymous) */
                        if(passwordCheck(lpUser,&buf[5]) || (bypass_passwd)) {  /* check for correct passwd, or check whether we bypassed the passwd from the keyboard */
                            if(bypass_passwd)       /* reset the bypassing flag */
                                bypass_passwd=0;
                            CRESP(pCon->socket,10); /* User logged in. */
                            GetAccessPaths(pCon);
                            pCon->ftpstate=5;
                        } else {
                            CRESP(pCon->socket,24);
                            pCon->ftpstate=3;
                        }
                    }
                    if (pCon->ftpstate==5)
                        wsprintf(strTmp,"User \"%ls\" logged in.\r\n",lpUser);
                      else
                        wsprintf(strTmp,"User \"%ls\" denied access.\r\n",lpUser);
//                    OutputDebugString(strTmp);
                    GlobalUnlock(pCon->hUser);
                } else      /* couldn't lock down username, freak out. */
                    CRESP(pCon->socket,39);
                break;
            }
            if(!lstrncmp("QUIT",buf,4)) {
                CRESP(pCon->socket,2);
            } else
                CRESP(pCon->socket,22);
            pCon->ftpstate=3;         /* must have password first */
            break;              
/*
*  interpret commands that are received from the other side
*/
        case 5:
            wsprintf(strTmp,"Command \"%ls\" received.\r\n",buf);
//            OutputDebugString(strTmp);
            for(i=4; i < lstrlen(buf); i++)
                if(buf[i]=='/')      /* flip slashes */
                    buf[i]='\\';
            if(!lstrncmp(buf,"QUIT",4)) {
                lpUser=(char far *)GlobalLock(pCon->hUser);
                if (lpUser) {
                    wsprintf(strTmp,"User \"%ls\" logged off.\r\n",lpUser);
//                    OutputDebugString(strTmp);
                    GlobalUnlock(pCon->hUser);
                }
                CRESP(pCon->socket,2);
                /* Here is where we should kill of the socket, etc.  */
            } else
            if(!lstrncmp(buf,"USER",4)) {
                lpUser=(char far *)GlobalLock(pCon->hUser);
                if (lpUser) {
                    int iNewUser=1;

                    if (*lpUser) {
                        wsprintf(strTmp,"User \"%ls\" changed login to ",lpUser);
//                        OutputDebugString(strTmp);
                        iNewUser=0;
                    }
                    lstrcpyn(lpUser,&buf[5],16);      /* keep user name */
                    i=lstrlen(lpUser);
                    do {
                        i--;
                        if (isalnum(lpUser[i]))
                            break;
                          else
                            lpUser[i]=0;
                    } while (i);
                    if (iNewUser) {
                        wsprintf(strTmp,"2User \"%ls\" login request.\r\n",lpUser);
//                        OutputDebugString(strTmp);
                    } else {
                        wsprintf(strTmp,"\"%ls\".\r\n",lpUser);
//                        OutputDebugString(strTmp);
                    }
                    GetAccessPaths(pCon);
                    if (FTP_access==2)      /* FTP access is unrestricted - don't need passwd */
                        CRESP(pCon->socket,10);     /* User logged in */
                      else {                /* FTP access is restricted - _DO_ need passwd */
                        pCon->iAnonymous=0;
                        switch (accessCheck(lpUser)) {
                            case NEED_PASSWORD:
                                CRESP(pCon->socket,23);     /* Password req */
                                pCon->ftpstate=4;           /* wait for password */
                                break;
                            case PASSWORD_NREQ:
                                CRESP(pCon->socket,10);     /* User logged in */
                                GetAccessPaths(pCon);
                                pCon->ftpstate=5;           /* "wait for command" state */
                                break;
                            case ANON_LOGIN:
                                pCon->iAnonymous=1;
                                CRESP(pCon->socket,25);     /* Ask for email address */
                                pCon->ftpstate=4;           /* wait for password */
                                break;
                            case ANON_LOGIN_DENIED:         /* anon. access turned off */
                                CRESP(pCon->socket,26);
                                pCon->ftpstate=3;
                                break;
                        }
                        GlobalUnlock(pCon->hUser);
                    }
                } else
                    CRESP(pCon->socket,39);
            } else
            if(!lstrncmp(buf,"LIST",4) || !lstrncmp(buf,"NLST",4)) {
                if(!lstrncmp(buf,"LIST",4)) {
                    if((lstrlen(buf)<6) || (buf[5]=='.'))
                        lstrcpy(buf,"LIST *");
                    lstype=1;
                } else {
                    if((lstrlen(buf)<6) || (buf[5]=='.'))
                        lstrcpy(buf,"NLST *");
                    lstype=0;
                }
//                OutputDebugString("Before CreateDirList...\r\n");
                i=CreateDirList(pCon,&buf[5],lstype);
//                OutputDebugString("After CreateDirList.\r\n");
                switch (i) {
                    case -1:
                        CRESP(pCon->socket,33);
                        break;
                    case 0:
                        CRESP(pCon->socket,1);
                        break;
                    default:
                        pCon->ftpDataState=FTPSTATE_SENDLIST;
                        if ((int)(pCon->datasocket=openFTPDataSocket(pCon))==SOCKET_ERROR) {
//                            OutputDebugString("Unable to create FTP data port!\r\n");
                            CRESP(pCon->socket,16);          /* For now */
                        } else {
//                            OutputDebugString("Created FTP data port!\r\n");
                            FCRESP(pCon->socket,4,(char far *)"ASCII",(char far *)"list");
                        }
                        break;
                }
            } else
            if (!lstrncmp(buf,"TYPE",4)) {
                switch (buf[5]) {
                    case 'i':
                    case 'I':
                        pCon->mode=FIMAGE;
                        CRESP(pCon->socket,7);
                        break;
                    case 'a':
                    case 'A':
                        pCon->mode=FASCII;
                        CRESP(pCon->socket,6);
                        break;
                    default:
                        CRESP(pCon->socket,17);
                }
            }
            else if(!lstrncmp(buf,"XPWD",4) || !lstrncmp(buf,"PWD",3)) {
                CRESP(pCon->socket,14);         /* start reply */
                lpPath=(char far *)GlobalLock(pCon->hPath);
                lstrcpy(buf,lpPath);
                GlobalUnlock(pCon->hPath);
                send(pCon->socket,buf,lstrlen(buf),NULL);   /* write dir name */
                CRESP(pCon->socket,15);         /* finish reply */
            }
            else if(!lstrncmp(buf,"CWD",3)) {
                wsprintf(strTmp,"<Received \"%ls\" command.>\r\n",buf);
//                OutputDebugString(strTmp);
                if (ChangeFTPDirectory(pCon,buf+4))
                    CRESP(pCon->socket,13);     /* success */
                  else
                    CRESP(pCon->socket,12);     /* failure */
            }
            else if(!lstrncmp(buf,"CDUP",4)) {
                ChangeFTPDirectoryUp(pCon);
                CRESP(pCon->socket,13);
            }
            else if(!lstrncmp(buf,"MKD",3)) {
                MungeNameToFullPathName(pCon,&buf[4]);
                if (!checkDirectoryAccess(pCon, &buf[4], WRITE_ACCESS)) {
                    CRESP(pCon->socket,34);     /* access denied */
                    break;
                }
                if (!makedir(&buf[4])) {         /* success */
                    CRESP(pCon->socket,14);     /* start reply */
                    send(pCon->socket,&buf[4],lstrlen(&buf[4]),NULL);  /* write dir name */
                    CRESP(pCon->socket,35);     /* finish reply */
                } else
                    CRESP(pCon->socket,36);     /* failure */
            }
            else if(!lstrncmp(buf,"RMD",3)) {   /* Check to see if this is a file - */
                i=RemovePathname(pCon,&buf[4],IS_DIRECTORY|IS_FILE);
                switch (i) {
                    case -1:
                        CRESP(pCon->socket,33);
                        break;
                    case 0:
                        CRESP(pCon->socket,11);
                        break;
                    default:
                        CRESP(pCon->socket,9);      /* success */
                }
            }
            else if(!lstrncmp(buf,"DELE",4)) {
                i=RemovePathname(pCon,&buf[5],IS_FILE);
                switch (i) {
                    case -1:
                        CRESP(pCon->socket,34);
                        break;
                    case 0:
                        CRESP(pCon->socket,11);
                        break;
                    default:
                        CRESP(pCon->socket,9);      /* success */
                }
            }
            else if(!lstrncmp(buf,"RETR",4)) {
                lstrcpy(strTmp,&buf[5]);

                iTmp=lstrlen(strTmp);
                while ((strTmp[iTmp]<20)&&(iTmp))
                    strTmp[iTmp--]='\0';

                MungeNameToFullPathName(pCon,&buf[5]);
                if (!checkDirectoryAccess(pCon, &buf[5], READ_ACCESS)) {
                    CRESP(pCon->socket,34);     /* access denied */
                    break;
                }
                if((pCon->hFile=_lopen(&buf[5], READ|OF_SHARE_DENY_WRITE)) == HFILE_ERROR) {
//                    OutputDebugString("Unable to open file!\r\n");
                    CRESP(pCon->socket,11);     /* failure */
                    break;
                } else {
//                    OutputDebugString("Opened file!\r\n");
                    pCon->wDataLen = pCon->wDataIdx = 0;
                    pCon->dwFileIdx=0;
                    if ((int)(pCon->datasocket=openFTPDataSocket(pCon))==SOCKET_ERROR) {
                        OutputDebugString("Unable to create FTP data port!\r\n");
                        CRESP(pCon->socket,16);          /* For now */
                    } else {
                        pCon->ftpDataState=FTPSTATE_SENDFILE;
                        OutputDebugString("Created FTP data port!\r\n");
                        FCRESP(pCon->socket,4,(pCon->mode==FASCII)?(char far *)"ASCII":(char far *)"BINARY",(char far *)strTmp);
                    }
                }
            }
            else if(!lstrncmp(buf,"STOR",4)) {
                char strFileTmp[80];

                lstrcpy(strFileTmp,&buf[5]);
                iTmp=lstrlen(strFileTmp);
                while ((strFileTmp[iTmp]<20)&&(iTmp))
                    strFileTmp[iTmp--]='\0';

                check_file_name(pCon,&buf[5]);
                if (!checkDirectoryAccess(pCon, &buf[5], WRITE_ACCESS)) {
                    CRESP(pCon->socket,34);     /* access denied */
                    break;
                }
                if((pCon->hFile=_lcreat(&buf[5], 0)) == HFILE_ERROR) {
                    OutputDebugString("Unable to create file!\r\n");
                    CRESP(pCon->socket,21);     /* failure */
                    break;
                } else {
                    pCon->wDataLen = pCon->wDataIdx = 0;
                    pCon->dwFileIdx=0;
                    if ((int)(pCon->datasocket=openFTPDataSocket(pCon))==SOCKET_ERROR) {
                        OutputDebugString("Unable to create FTP data port!\r\n");
                        CRESP(pCon->socket,21);
                    } else {
                        pCon->ftpDataState=FTPSTATE_RECVFILE;
                        FCRESP(pCon->socket,4,(pCon->mode==FASCII)?(char far *)"ASCII":(char far *)"BINARY",(char far *)strFileTmp);
                    }
                }
            }
            else if(!lstrncmp(buf,"HELP",4)) {
                for(i=28; i<33; i++)
                    CRESP(pCon->socket,i);
            }
            else if(!lstrncmp(buf,"STRU",4)) {    /* only one stru allowed */
                if(buf[5]=='F')
                    CRESP(pCon->socket,18);
                else
                    CRESP(pCon->socket,17);
              } /* end if */
            else if(!lstrncmp(buf,"MODE",4)) {
                if(buf[5]=='S')
                    CRESP(pCon->socket,19);
                else
                    CRESP(pCon->socket,17);
              } /* end if */
            else if (!lstrncmp(buf,"ALLO",4) || !lstrncmp(buf,"ACCT",4))
                CRESP(pCon->socket,20);
            else if (!lstrncmp(buf,"NOOP",4))
                CRESP(pCon->socket,9);
            else if (!lstrncmp(buf,"ABOR",4)) {
                if (pCon->datasocket != SOCKET_ERROR) {
                    if (pCon->hFile != HFILE_ERROR)
                        _lclose(pCon->hFile);
                    pCon->hFile = HFILE_ERROR;
//                    OutputDebugString("Abort 1.\r\n");
                    CRESP(pCon->socket,38);
                    if (closesocket(pCon->datasocket))
                        OutputDebugString("Error closing FTP data socket!\r\n");
                    pCon->ftpDataState=FTPSTATE_CLOSED;
                    pCon->datasocket = (UINT)SOCKET_ERROR;
                }
//                OutputDebugString("Abort 2.\r\n");
                CRESP(pCon->socket,5);
            } else if (!lstrncmp(buf,"PORT",4)) {
                int iBufTmp[6];
                unsigned char bufTmp[256];

                _fmemcpy((char far *)bufTmp, (char far *)&buf[5],256);
                sscanf(bufTmp,"%d,%d,%d,%d,%d,%d",&iBufTmp[0],&iBufTmp[1],
                       &iBufTmp[2],&iBufTmp[3],&iBufTmp[4],&iBufTmp[5]);
                pCon->sa.sin_addr.S_un.S_un_b.s_b1=iBufTmp[0];
                pCon->sa.sin_addr.S_un.S_un_b.s_b2=iBufTmp[1];
                pCon->sa.sin_addr.S_un.S_un_b.s_b3=iBufTmp[2];
                pCon->sa.sin_addr.S_un.S_un_b.s_b4=iBufTmp[3];
                pCon->sa.sin_port = htons(iBufTmp[4]*256+iBufTmp[5]);
                CRESP(pCon->socket,3);
            }

            else if (!lstrncmp(buf,"REIN",4) || !lstrncmp(buf,"PASV",4) || 
                     !lstrncmp(buf,"APPE",4) || !lstrncmp(buf,"REST",4) || 
                     !lstrncmp(buf,"RNFR",4) || !lstrncmp(buf,"RNTO",4) || 
                     !lstrncmp(buf,"ABOR",4) || !lstrncmp(buf,"SITE",4) || 
                     !lstrncmp(buf,"STAT",4) || !lstrncmp(buf,"SMNT",4) || 
                     !lstrncmp(buf,"SMNT",4) || !lstrncmp(buf,"SYST",4) || 
                     !lstrncmp(buf,"STOU",4))      /* unimplemented commands */
                CRESP(pCon->socket,37);

              else {           /* command not understood */
                CRESP(pCon->socket,8);
                wsprintf(strTmp,"\r\nCommand \"%ls\" not understood.\r\n",buf);
//                OutputDebugString(strTmp);
            }
            break;
    }
}

int ProcessFTPDataCommand(FTPCON far *pCon) {
    WORD i;
    int iToSend,iRet;
    char far *lpData;
    fd_set filedes;
    unsigned long count;
    int cnt;

    if (pCon->datasocket==SOCKET_ERROR) {
        OutputDebugString("No data socket open!\r\n");
        return(0);
    }
    switch (pCon->ftpDataState) {
        case FTPSTATE_SENDLIST:
            FD_ZERO(&filedes);
            FD_SET(pCon->datasocket,&filedes);
            if (select(0,NULL,(fd_set FAR *)&filedes,NULL,NULL)) {  /* test for writeability */
                if (FD_ISSET(pCon->datasocket,&filedes)) {
                    i=pCon->wDataLen - pCon->wDataIdx;
                    iToSend=min((WORD)PACKET_SIZE,i);
                    lpData=(char far *)GlobalLock(pCon->hData);
                    if (!lpData) {
                        OutputDebugString("Error! Could not lock down data handle!\r\n");
                        return(0);
                    }
                    iRet=send(pCon->datasocket,&lpData[pCon->wDataIdx],iToSend,NULL);
                    if (iRet==SOCKET_ERROR) {
                        OutputDebugString("send() returned error.\r\n");
                        return(0);
                    }
                    pCon->wDataIdx+=iRet;
                    if (pCon->wDataIdx==pCon->wDataLen) {
                        CRESP(pCon->socket,5);
                        if (closesocket(pCon->datasocket))
                            OutputDebugString("Error closing FTP data socket!\r\n");
                        pCon->ftpDataState=FTPSTATE_CLOSED;
                    }
                }
            }
            return(1);
            break;

        case FTPSTATE_SENDFILE:
            FD_ZERO(&filedes);
            FD_SET(pCon->datasocket,&filedes);
            if (select(0,NULL,(fd_set FAR *)&filedes,NULL,NULL)) {  /* test for writeability */
                if (FD_ISSET(pCon->datasocket,&filedes)) {
                    i=pCon->wDataLen - pCon->wDataIdx;
                    if (i==0) {
                        if (pCon->mode==FASCII)
                            ReadASCIIFileBlock(pCon);
                          else
                            ReadFileBlock(pCon);
                        i=pCon->wDataLen - pCon->wDataIdx;
                        if (i==0) {
                            CRESP(pCon->socket,5);
                            wsprintf(strTmp,"Wrote %lu bytes to net.\r\n",pCon->dwFileIdx);
//                            OutputDebugString(strTmp);
//                            OutputDebugString("Done, closing data socket!\r\n");
                            if (closesocket(pCon->datasocket))
//                                OutputDebugString("Error closing FTP data socket!\r\n");
                            pCon->ftpDataState=FTPSTATE_CLOSED;
                            return(1);
                        }
                    }
                    iToSend=(int)(min((WORD)PACKET_SIZE,i));
                    lpData=(char far *)GlobalLock(pCon->hData);
                    if (!lpData) {
                        OutputDebugString("Error! Could not lock down data handle!\r\n");
                        return(0);
                    }
                    iRet=send(pCon->datasocket,&lpData[pCon->wDataIdx],iToSend,NULL);
                    if (iRet==SOCKET_ERROR) {
                        OutputDebugString("send() returned error.\r\n");
                        return(0);
                    }
                    pCon->wDataIdx+=iRet;
                }
            } 
            return(1);
            break;

        case FTPSTATE_RECVFILE:
            if (ioctlsocket((SOCKET)pCon->datasocket,(long)FIONREAD,(u_long FAR *)&count)==
                        SOCKET_ERROR) {     /* Socket was closed by other end */
                CRESP(pCon->socket,5);
                WriteFileBlock(pCon,1);
                wsprintf(strTmp,"Transfer done - read %lu bytes from net.\r\n",pCon->dwFileIdx);
//                OutputDebugString(strTmp);
                pCon->ftpDataState=FTPSTATE_CLOSED;
                return(1);
            }
            if (count) {
                i=DATA_BUF_SIZE - pCon->wDataIdx;
                if (i==0) {
                    WriteFileBlock(pCon,0);
                    i=DATA_BUF_SIZE - pCon->wDataIdx;
                }
                i=min(i,32767); /* max that fits in the int we need to pass recv() */
                lpData=(char far *)GlobalLock(pCon->hData);
                if (!lpData) {
                    OutputDebugString("Error! Could not lock down data handle!\r\n");
                    return(0);
                }
                cnt=recv(pCon->datasocket,&lpData[pCon->wDataIdx],(int)i,NULL);
//                buf[cnt]=0;
#ifdef NEEDED
                if (!count) {
                    CRESP(pCon->socket,5);
                    wsprintf(strTmp,"Transfer done - read %lu bytes from net.\r\n",pCon->dwFileIdx);
//                    OutputDebugString(strTmp);
                    pCon->ftpDataState=FTPSTATE_CLOSED;
                    return(1);
                }
#endif
                if (cnt==SOCKET_ERROR) {
                    OutputDebugString("recv() returned error.\r\n");
                    return(0);
                }
                pCon->wDataIdx+=cnt;
            }
            return(1);
            break;
    }
    return(0);
}


